#ifndef IMAGE_H_
#define IMAGE_H_

typedef struct {
	Point center;
	double radius;
	int isCCW;
} Circle;

typedef struct {
	struct {
		double min;
		double max;
	} h;
	struct {
		double min;
		double max;
	} s;
	struct {
		double min;
		double max;
	} v;
} ImageHSV;

Point imageGetBall(int number, ImageHSV hsv);
int imageSave(int number, char* fileName);

#endif
