#include<stdio.h>
#include<math.h>
#include <unistd.h>
#include"Define.h"
#include"Extern.h"
#include"../Run/run_ctrl.h"
#include"../Run/encoder.h"
#include"../Run/vel_ctrl.h"

#define __DEBUG__

//目標地点へ移動
void GetTarget(Point BeforePosition,Point Destination){
	double x,y,Deg;					//x,y=進行距離x,y成分//Deg=進行角度(絶対角度)//Angle(回転角)
	int Angle,Flag;
	encoder_create();
	vel_ctrl_create();

#ifdef __DEBUG__
	printf("GetTargetDistxyDestinationxy%f\t%f\t%f\t%f\n",BeforePosition.x,BeforePosition.y,Destination.x,Destination.y);
#endif

//現在地パターン
	int Pattern[2];

	Pattern[0]=GetPattern(BeforePosition);
	Pattern[1]=GetPattern(Destination);

	Flag=PatternSkip(Pattern);

#ifdef __DEBUG__
	printf("現在地パターン%d\t目標値パターン%d\n",Pattern[0],Pattern[1]);
#endif

//経路算出
	int speed = 40;
	int tspeed = 20;

	if(Flag==1) goto first;
	switch(Pattern[0]){		//中心まで
		case 1 :
			x=75-BeforePosition.x;
			y=125-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			x=75-BeforePosition.x;
			y=175-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			break;
		case 2 :break;
		case 3 :
			x=375-BeforePosition.x;
			y=125-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			x=375-BeforePosition.x;
			y=125-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
	
			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;	
			break;
		case 4 :break;
		case 5 :break;
		case 6 :break;
		case 7 :
			x=75-BeforePosition.x;
			y=325-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			x=25-BeforePosition.x;
			y=325-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			x=25-BeforePosition.x;
			y=275-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			break;
		case 8 :break;
		case 9:
			x=325-BeforePosition.x;
			y=375-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			x=325-BeforePosition.x;
			y=425-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			x=275-BeforePosition.x;
			y=425-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			break;
	}

	x=225-BeforePosition.x;
	y=225-BeforePosition.y;
	Deg=GetDeg(x,y);
	Angle=BeforePosition.angle-Deg;
	if(Angle<0){
		tspeed=abs(tspeed);
	}else if(Angle<0){
		tspeed=-abs(tspeed);
	}else if(Angle>0){
		tspeed=0;
	}else printf("AngleERROR");
#ifdef __DEBUG__
	printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif

//旋回
	run_ctrl_set(ROTATE, (float)tspeed);
	run_ctrl_set_dist((float)Angle);
	run_ctrl_create();
	while(run_ctrl_get_endflag()!=1) usleep(20000);
	run_ctrl_cancel();
//前進
	run_ctrl_set(STRAIGHT, (float)speed);
	run_ctrl_set_dist((float)hypot(x,y));
	run_ctrl_create();
	while(run_ctrl_get_endflag()!=1) usleep(20000);
	run_ctrl_cancel();

	BeforePosition.x+=x;
	BeforePosition.y+=y;
first:

	switch(Pattern[1]){		//目的地まで
		case 1 :
			x=75-BeforePosition.x;
			y=175-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			x=75-BeforePosition.x;
			y=125-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			break;
		case 2 :break;
		case 3 :
			x=375-BeforePosition.x;
			y=175-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			x=375-BeforePosition.x;
			y=75-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			break;
		case 4 :break;
		case 5 :break;
		case 6 :break;
		case 7 :
			x=25-BeforePosition.x;
			y=275-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			x=25-BeforePosition.x;
			y=325-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			x=75-BeforePosition.x;
			y=325-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			break;
		case 8 :break;
		case 9 :
			x=275-BeforePosition.x;
			y=425-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
//旋回
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			x=325-BeforePosition.x;
			y=425-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
			run_ctrl_cancel();

/*			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
			x=325-BeforePosition.x;
			y=375-BeforePosition.y;
			Deg=GetDeg(x,y);
			Angle=BeforePosition.angle-Deg;
			if(Angle>0){
				tspeed=abs(tspeed);
			}else if(Angle<0){
				tspeed=-abs(tspeed);
			}else if(Angle==0){
				tspeed=0;
			}else printf("AngleERROR");
#ifdef __DEBUG__
			printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
			run_ctrl_set(ROTATE, (float)tspeed);
			run_ctrl_set_dist((float)Angle);
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);
//前進
			run_ctrl_set(STRAIGHT, (float)speed);
			run_ctrl_set_dist((float)hypot(x,y));
			run_ctrl_create();
	                while(run_ctrl_get_endflag()!=1) usleep(20000);

			BeforePosition.x+=x;
			BeforePosition.y+=y;
			BeforePosition.angle=Deg;
*/			break;
	}
	x=Destination.x-BeforePosition.x;
	y=Destination.y-BeforePosition.y;
	Deg=GetDeg(x,y);
	Angle=BeforePosition.angle-Deg;
	if(Angle>180){
		Angle=360-Angle;
	}else if(Angle<-180){
		Angle=360+Angle;
	}
	if(Angle<0){
		tspeed=abs(tspeed);
	}else if(Angle<0){
		tspeed=-abs(tspeed);
	}else if(Angle>0){
		tspeed=0;
	}else printf("AngleERROR");
#ifdef __DEBUG__
	printf("Angle=%d\ttspeed=%d\n",Angle,tspeed);
#endif
//旋回
	run_ctrl_set(ROTATE, (float)tspeed);
	run_ctrl_set_dist((float)Angle);
	run_ctrl_create();
	while(run_ctrl_get_endflag()!=1) usleep(20000);
	run_ctrl_cancel();
//前進
	run_ctrl_set(STRAIGHT, (float)speed);
	run_ctrl_set_dist((float)hypot(x,y));
	run_ctrl_create();
	while(run_ctrl_get_endflag()!=1) usleep(20000);
	run_ctrl_cancel();

	BeforePosition.x+=x;
	BeforePosition.y+=y;
	BeforePosition.angle=Deg;

#ifdef __DEBUG__
	printf("GetTaret End\n");
#endif
	return;
}
