// タスクの生成・初期化
// 作成日：2013/1/10

#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "device.h"
#include "hardware.h"
#include "uss.h"

static pthread_t tasks[1];

static void *thread_code(void *t){

	int counter=0;
	int uss_data;
	int i;

	printf("Test_USS thread created!  \n");

	while(1){
		counter++;

		for(i=1;i<=4;i++){
			uss_data=uss_get(i);
			printf("uss[%d]=%3d    ",i,uss_data);
			usleep(50000);
		}
		printf("\n");

		//usleep((T_TEST-1)*1000);
		sleep(1);

	}


	return 0;

}

static int thread_create()
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	pthread_attr_init(&attr);
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	ret = pthread_create(&tasks[0], &attr, thread_code, (void *)2);

	return 0;
}

void test_uss(){

/*
	int s_val;
	printf("PWM value [right]= ");
	s_val=scanf("%d",&pwm_duty_r);
	printf("PWM value [left]= ");
	s_val=scanf("%d",&pwm_duty_l);
*/

	//encoder_create();

	thread_create();
	printf("thread_id=%d\n",(int)tasks[0]);
	pthread_join(tasks[0],NULL);
	printf("Program stopped\n");

}


