#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include"../Run/device.h"
#include"../Run/hardware.h"
#include"../Run/encoder.h"
#include"../Run/vel_ctrl.h"

int main(void){
	int ret_val;

	ret_val=device_encoder_open();
	ret_val=device_motor_open();
	ret_val=device_uss_open();
	ret_val=device_io_open();

	encoder_create();
	vel_ctrl_create();

	Chase();

	ret_val=device_encoder_close();
	ret_val=device_motor_close();
	ret_val=device_uss_close();
	ret_val=device_io_close();

	return 0;
}
