#define ROW_MAX	9			//マップのマス数
#define COLUMN_MAX 9
#define DATA_MAX 19
#define SIDE_LENGTH 50
#define RAD(x) (x/180)*M_PI
#define DEG(x) (x/M_PI)*180

typedef enum{
	NONE,		//オブジェクトなし
	WALL,		//壁
	ENTRANCE,	//小部屋出入り口
	START,		//スタート位置
	TREASURE,	//宝
	DIRECTION	//ダイレクションボード
}ObjectType;

typedef  struct{
	double x;
	double y;
	double angle;
}Point;

typedef struct {
	int Right;	//ObjectType
	int Up;
	int Left;
	int Down;
} Mawari;

typedef struct {
	Point Center;	//中心座標
	int Row;	//行
	int Column;	//列
	ObjectType Object;
	Mawari Around;
} MapDetail;

MapDetail Info[ROW_MAX][COLUMN_MAX];

