#ifndef MapExtern
#define MapExtern

extern int Judge(char a);
extern void GetTarget(Point BeforePosition,Point Destination);
extern int MapOpen(MapDetail Info[ROW_MAX][COLUMN_MAX]);
extern double GetDeg(double x,double y);
extern int ObjectCheck(MapDetail Info[ROW_MAX][COLUMN_MAX]);
extern int GetPattern(Point Position);
extern int PatternSkip(int *Pattern);

//extern double PrePosition(double *p,double Angle,int Flag);				//encoder
extern double PrePosition(double *p,double AfterDistance,double AfterAngle,int Flag);	//calculation
extern void PositionStart(void);
//extern double PrePosition(double *p,double Angle,int Flag);			//thread
extern int ClearPosition();
extern int SetPosition(Point Pointer);
extern int GetPosition(Point Pointer);
extern int UssPosition();
extern void PositionThreadCancel();

/*****補足説明*****
GetTarget
	BeforePosition	最初の地点のx,y座標(距離),絶対角度
	Destination	目標地点のx,y座標(距離),絶対角度

PrePosition
	p		現在地を返すための値
	AfterDistance	次に前進する距離
	AfterAngle	旋回した後の方向(絶対角度)


******************/

#endif
