#include<stdio.h>
#include<math.h>
#include"Define.h"

//#define __DEBUG__
#define __DEBUG_DEG__

int Judge(char a){
	int i=0;
	switch(a){
		case'w':i=WALL;	break;
		case's':i=START;	break;
		case'e':i=ENTRANCE;	break;
		case't':i=TREASURE;	break;
		case'd':i=DIRECTION;	break;
		case'*':i=NONE;	break;
		default:break;
	}
	return i;
}

int MapOpen(MapDetail Info[ROW_MAX][COLUMN_MAX]){
	int Row,Column;
	char Buffer[COLUMN_MAX*8];
	char MapData[ROW_MAX*2+1][COLUMN_MAX*2+1];
//	MapDetail Info[ROW_MAX][COLUMN_MAX];

	// 初期化
	for(Row=0; Row<sizeof(MapData)/sizeof(MapData[0]); Row++){
		for(Column=0; Column<sizeof(MapData[0])/sizeof(MapData[0][0]); Column++){
			MapData[Row][Column] = 'X';
		}
	}

	//ファイルオープン
	FILE *fp;
	fp=fopen("map.csv","r");
	if(fp==NULL)printf("fopenERROR\n");

	//データロード
	for(Row=0; fgets(Buffer,sizeof(Buffer),fp) != NULL; Row++){
		int i;
		for(i=0,Column=0; Column<DATA_MAX && Buffer[i] != '\0'; i++){
			if(Buffer[i] != ' ' && Buffer[i] != '\t'&& Buffer[i] != '\n'){
				MapData[Row][Column] = Buffer[i];
#ifdef __DEBUG__
				printf("%c",MapData[Row][Column]);	//表示
#endif
				Column++;
			}
		}
//	printf("\n");							//表示改行
	}
	fclose(fp);
#ifdef __DEBUG__
	printf("%d\t%d\t%d\t%d\t%d\t%d\n",NONE,WALL,ENTRANCE,START,TREASURE,DIRECTION);
#endif

	//データ照合
	for(Row=0;Row<ROW_MAX;Row++){
		for(Column=0;Column<COLUMN_MAX;Column++){
			Info[Row][Column].Row=Row;
			Info[Row][Column].Center.y=Row*SIDE_LENGTH+SIDE_LENGTH/2;
			Info[Row][Column].Column=Column;
			Info[Row][Column].Center.x=Column*SIDE_LENGTH+SIDE_LENGTH/2;
			switch(MapData[Row*2+1][Column*2+1]){
				case 's':Info[Row][Column].Object=START;	break;
				case 'e':Info[Row][Column].Object=ENTRANCE;	break;
				case 't':Info[Row][Column].Object=TREASURE;	break;
				case 'd':Info[Row][Column].Object=DIRECTION;	break;
				case 'w':Info[Row][Column].Object=WALL;	break;
				case '*':Info[Row][Column].Object=NONE;	break;
				default:break;
			}
//周囲オブジェクトchar表示
#ifdef __DEBUG__
			printf("%c\t%c\t%c\t%c\n",MapData[Row*2+1][Column*2+2],MapData[Row*2][Column*2+1],MapData[Row*2+1][Column*2],MapData[Row*2+2][Column*2+1]);
#endif
			Info[Row][Column].Around.Right=Judge(MapData[Row*2+1][Column*2+2]);
			Info[Row][Column].Around.Up=Judge(MapData[Row*2][Column*2+1]);
			Info[Row][Column].Around.Left=Judge(MapData[Row*2+1][Column*2]);
			Info[Row][Column].Around.Down=Judge(MapData[Row*2+2][Column*2+1]);
//行列要素番号、直行座標、表示
#ifdef __DEBUG__
			printf("%d\t%d\t\t%f\t%f\n",Info[Row][Column].Row,Info[Row][Column].Column,Info[Row][Column].Center.x,Info[Row][Column].Center.y);
//周囲オブジェクトenum表示
			printf("%d\t%d\t%d\t%d\n",Info[Row][Column].Around.Right,Info[Row][Column].Around.Up,Info[Row][Column].Around.Left,Info[Row][Column].Around.Down);
#endif
		}
	}
	return 0;
}

//目標角度
double GetDeg(double xd,double yd){
	int x = xd;
	int y = -yd;
#ifdef __DEBUG_DEG__
	printf("x,y\t%d\t%d\n",x,y);
#endif
	double Rad,Deg;
	if(x>0){
		if(y>0){
printf("1\t");
			Rad=atan(y/x);
			Deg=DEG(Rad);
		}else if(y<0){
printf("2\t");
			Rad=atan(y/x);
			Deg=DEG(Rad);
		}else{
printf("3\t");
			Deg=0;
		}
	}else if(x<0){
		if(y>0){
printf("4\t");
			Rad=atan(y/x);
			Deg=(double)abs((int)DEG(Rad))+180;
		}else if(y<0){
printf("5\t");
			Rad=atan(y/x);
			Deg=-(double)abs((int)DEG(Rad))-180;
		}else{
printf("6\t");
			Deg=180;
		}
	}else if(x==0){
		if(y>0){
printf("7\t");
			Deg=90;
		}else if(y<0){
printf("8\t");
			Deg=-90;
		}else{
printf("9\t");
			Deg=0;
		}
	}else printf("else\n");
#ifdef __DEBUG_DEG__
	printf("GetDeg%f\n",Deg);
#endif
	return Deg;
}
