#include<stdio.h>
#include<math.h>
#include <pthread.h>
#include"Define.h"
#include"../Run/distance.h"
#include"../Run/uss.h"
#include"../Run/run_ctrl.h"

#define RADIAN(x) (x*(M_PI/180))

#define K 23.5 //車体の直径(タイヤ中心から中心)
#define __DEBUG__

static Point Position={225,425,90};
static int Pattern=0;
static pthread_t task_id;

void *PrePosition(){
	Point p;
	static float dist=0;
	static float distp=0,dists=0;
//	struct distance_data dist_new={0,0};
//	struct distance_data dist_past={0,0};
	struct distance_data distance={0,0};
	while(1){
		distance_get(&distance);
//		distance.left=dist_past.left-dist_new.left;
//		distance.right=dist_past.right-dist_new.right;
		distp=((distance.left+distance.right)/2);
		if(dist<0)dist=dist*(-1);
		
#ifdef __DEBUG__
printf("distance_data\t%f\t%f\tdist=%f\n",distance.left,distance.right,dist);
#endif
		if(distance.left>0){
			if(distance.right>0){
printf("1\n");
				//両方正の場合・前進
				Position.x+=dist*cos(RADIAN(Position.angle));
				Position.y+=dist*sin(RADIAN(Position.angle));
			}else if(distance.right<0){
printf("2\n");
				//右だけが負の場合・右旋回
				Position.angle-=((dist)/(K*M_PI))*180;
			}else if(distance.right==0){
				printf("right = 0\n");
			}else printf("else right\n");
		}else if(distance.left<0){
			if(distance.right<0){
printf("3\n");
				//両方負の場合・後退
				Position.x-=dist*cos(RADIAN(Position.angle));
				Position.y-=dist*sin(RADIAN(Position.angle));
			}else if(distance.right>0){
printf("4\n");
				//左だけが負の場合・左旋回
				Position.angle+=((dist)/(K*M_PI))*180;
			}else if(distance.right==0){
				printf("right = 0\n");
			}else printf("else right\n");
		}else if(distance.left==0){
			printf("left = 0\n");
		}
//		dist_past=distance;
		dists=dist;
		Pattern=GetPattern(Position);
#ifdef __DEBUG__
		printf("Position={%f,%f,%f}\n",Position.x,Position.y,Position.angle);
#endif
		usleep(5*1000*100);
	}
	return 0;
}

int ClearPosition(){
	Position.x=0;
	Position.y=0;
	Position.angle=0;
	return 0;
}

int GetPosition(Point Pointer){
	Pointer.x=Position.x;
	Pointer.y=Position.y;
	Pointer.angle=Position.angle;
	return 0;
}

int SetPosition(Point Pointer){
	Position.x=Pointer.x;
	Position.y=Pointer.y;
	Position.angle=Pointer.angle;
	return 0;
}

void PositionThreadCancel(){

	pthread_cancel(task_id);

}

int UssPosition(){
	int dist_f,dist_l,dist_r,dist1,dist2,dist,gap;
	dist1=uss_get(1);dist=uss_get(2);dist_l=uss_get(3);dist_r=uss_get(4);
	if(dist1>300)dist1=350;if(dist2>300)dist2=350;if(dist_l>300)dist_l=350;if(dist_r>300)dist_r=350;
	dist_f=(dist1+dist2)/2;
	switch(Pattern){
		case 1:if(dist_r>dist_l){
				gap=dist_r-dist_l;
				if(dist_l<1){
					
				}else if(gap<20&&gap>-25){

				}else printf("ERROR");
			}else if(dist_r<dist_l){

			}else if(dist_r=dist_l){

			}else printf("UssDistanceERROR");
			break;
		case 2:if(dist_r>dist_l){
				Position.x=225;
				Position.y=dist_l+K/2;
				Position.angle=0;
			}else if(dist_r<dist_l){
				if(dist_l<=300){
					Position.x=dist_r+K/2;
					Position.y=75;
					Position.angle=90;
				}else{
					Position.x=225;
					Position.y=dist_l+K/2;
					Position.angle=0;
				}
			}else if(dist_r=dist_l){
				Position.x=300-(dist_r+K/2);
				Position.y=75;
				Position.angle=90;
			}else printf("UssDistanceERROR");
			break;
		case 3:if(dist_r>dist_l){
		
			}else if(dist_r<dist_l){

			}else if(dist_r=dist_l){

			}else printf("UssDistanceERROR");
			break;
		case 4:if(dist_r>dist_l){
				if(dist_r<=300){
					Position.x=75;
					Position.y=3000-(dist_l+K/2);
					Position.angle=180;
				}else{
					Position.x=dist_l+K/2;
					Position.y=225;
					Position.angle=90;		
				}
			}else if(dist_r<dist_l){
				Position.x=dist_r+K/2;
				Position.y=225;
				Position.angle=270;
//おそらくない			}else if(dist_r=dist_l){
				Position.x=0;
				Position.y=0;
				Position.angle=0;
			}else printf("UssDistanceERROR");
			break;
		case 5:printf("Center Of The Map");
			break;
		case 6:if(dist_r>dist_l){
				Position.x=450-(dist_l+K/2);
				Position.y=225;
				Position.angle=270;
			}else if(dist_r<dist_l){
				if(dist_l<=300){
					Position.x=425;
					Position.y=300-(dist_r+K/2);
					Position.angle=0;
				}else{
					Position.x=450-(dist_r+K/2);
					Position.y=225;
					Position.angle=90;
				}
			}else if(dist_r=dist_l){
				Position.x=dist_r+K/2;
				Position.y=225;
				Position.angle=270;
			}else printf("UssDistanceERROR");
			break;
		case 7:if(dist_r>dist_l){
		
			}else if(dist_r<dist_l){

			}else if(dist_r=dist_l){

			}else printf("UssDistanceERROR");
			break;
		case 8:if(dist_r>dist_l){
				Position.x=0;
				Position.y=0;
				Position.angle=0;		
			}else if(dist_r<dist_l){
				Position.x=0;
				Position.y=0;
				Position.angle=0;
			}else if(dist_r=dist_l){
				Position.x=0;
				Position.y=0;
				Position.angle=0;
			}else printf("UssDistanceERROR");
			break;
		case 9:if(dist_r>dist_l){
		
			}else if(dist_r<dist_l){

			}else if(dist_r=dist_l){

			}else printf("UssDistanceERROR");
			break;
	}
	return 0;
}

void PositionStart(){

	distance_reset();

	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;
	int policy;

	pthread_attr_init(&attr);

	// 優先度10、ポリシーFIFOでスレッド生成
	sched_param.sched_priority = 10;
	pthread_attr_setschedparam(&attr, &sched_param);
	pthread_setschedparam(pthread_self(), SCHED_FIFO , &sched_param);

	ret = pthread_create(&task_id, &attr, PrePosition,NULL);

	pthread_getschedparam(pthread_self(), &policy, &sched_param);
	printf("plicy = %s, priority =%d\n",
		(policy == SCHED_FIFO)  ? "SCHED_FIFO" :
		(policy == SCHED_RR)    ? "SCHED_RR" :
		(policy == SCHED_OTHER) ? "SCHED_OTHER" :
		"???",
		sched_param.sched_priority);

}

