#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>

#include "avoid.h"
#include "direction.h"
#include "distance.h"
#include "encoder.h"
#include "device.h"
#include "run_ctrl.h"
#include "io.h"

volatile int check_flag = 0;
volatile int touch_flag = 0;
//int touch_flag = 0;

/* 引数 今の壁との距離 */
int avoid() {

	//printf("run_back start in avoid!\n");
		/* 後ろに下がる */

	switch(touch_flag){
		case 1:
			printf("case1\n");
			touch_flag = 0;

			run_ctrl_set(STRAIGHT, (float)BACK_SPEED);
			run_ctrl_set_dist((float)(BACK_DISTANCE));

			//printf("終了\n");
			//run_ctrl_stop();

			/* 正体補正 */
			printf("direction correction start!\n");
			direction_correct((int)(-BACK_DISTANCE));
			
			check_flag = 1;

			//run_ctrl_cancel();
		
			break;

		case 2:
			printf("case2\n");
			touch_flag = 0;

			printf("一旦下がる\n");

			run_ctrl_set(STRAIGHT, (float)FORWARD_SPEED);
			run_ctrl_set_dist((float)PRE_DISTANCE);
	
			//motor_drive(0, 0);


			printf("回転処理\n");

			run_ctrl_set(ROTATE, (float)ROTATE_SPEED);
			run_ctrl_set_dist((float)ROTATE_DISTANCE);

			//motor_drive(0, 0);

			printf("回転後の処理\n");

			run_ctrl_set(STRAIGHT, (float)(-FORWARD_SPEED));
			run_ctrl_set_dist((float)(-FORWARD_DISTANCE));

			/* 正体補正 */
			printf("direction correction start!\n");
			direction_correct((int)(FORWARD_DISTANCE + PRE_DISTANCE));
			
			check_flag = 1;

		default:

			break;
	
	}			

	return 0;

}

int check_touch(){

	//int i;

	char io_mdata[12];

		if(check_flag == 1){
			check_flag = 0;
			return 1;		//関数の強制終了
		}

        io_get(io_mdata);

		if(io_mdata[0] == '1' || io_mdata[1] == '1' || io_mdata[2] == '1'){
			touch_flag = 1;
		} else if(io_mdata[3] == '1' || io_mdata[4] == '1' || io_mdata[5] == '1'){
			touch_flag = 2;
		}
		
		avoid();

	usleep(100000);

	


	return 0;

}

