#ifndef HARDWARE_H_
#define HARDWARE_H_

//ロータリエンコーダの更新周期 [ms]
#define T_ENCODER 20 

//モータ速度制御の制御周期 [ms]
#define T_VEL_CTRL 20 

//走行制御のの更新周期 [ms]
#define T_RUN_CTRL 20 

//ディフォルトの制御周期 [ms]
#define T_CTRL 20 

//テストプログラムの結果確認周期 [ms]
#define T_TEST 20 

// for STANDARD MIRS
// タイヤ半径 [cm]
//#define TIRE_R 5.6 
#define TIRE_R 5.7

// タイヤ間距離 [cm]
//#define BETWEEN_TIRE 30.0 
#define BETWEEN_TIRE 23.5 

//右タイヤを１とした場合の左タイヤの走行距離補正値
//#define TIRE_DIST_RATIO  1.00
#define TIRE_DIST_RATIO  1.0375

//エンコーダ [パルス/周] ４倍時 360x4 = 1440
#define ENC_PPS  1440 

// モータとエンコーダの回転比率 = モータ軸直径/エンコーダプーリ直径
//#define M_E_RATIO 0.6875
#define M_E_RATIO 0.8384

// カメラと正面USS先端の距離差
#define CAM_USS_DIF 4

#endif
