/*
速度制御	2014/7/3
*/
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "device.h"
#include "hardware.h"
#include "encoder.h"
#include "vel_ctrl.h"
#include "direction.h"
#include "number.h"

void test_dir_num(){


	int ret_val;
	int dist;
	//int number_l, number_r;
	int numbers[2];
	int nums = 1; //ボード上の数字の個数（1 または 2）

	encoder_create();
	vel_ctrl_create();

	printf("正体補正する距離[cm] = ");
	ret_val=scanf("%d",&dist);

	ret_val = direction_correct(dist);
	if(ret_val==1){
		printf("正体補正 成功！");

	}else{
		printf("正体補正 失敗！");
	}

	//数字認識
	number_set_nums(nums);
	ret_val = number_detect(dist-CAM_USS_DIF); //数字認識
	//ret_val = number_detect(dist-4); //数字認識
	//number_get(&number_l, &number_r);
	number_get(numbers);
	if(nums==1){
		printf("数字=%d\n",numbers[0]);
	}
	if(nums==2){
		printf("左数字=%d、右数字=%d\n",numbers[0],numbers[1]);
	}

	printf("Program stopped\n");

}

