// タスクの生成・初期化
// 作成日：2013/1/10

#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "device.h"
#include "hardware.h"
#include "distance.h"
#include "encoder.h"

static pthread_t tasks[1];

static void *thread_code(void *t){

	int counter=0;
	struct distance_data distance_data;

	while(1){
		counter++;

		//if(counter > 200) break;

		//distance_get(&distance_l, &distance_r);
		distance_get(&distance_data);
		printf("distance_l=%8.3f    distance_l=%8.3f\n",distance_data.left,distance_data.right);

		usleep((T_TEST-1)*1000);
		//usleep(19000); // 19msec →　スケジューラで20msec weight と等価

	}


	return 0;

}

static int thread_create()
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	pthread_attr_init(&attr);
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	ret = pthread_create(&tasks[0], &attr, thread_code, (void *)2);

	return 0;
}

void test_distance(){

/*
	int s_val;
	printf("PWM value [right]= ");
	s_val=scanf("%d",&pwm_duty_r);
	printf("PWM value [left]= ");
	s_val=scanf("%d",&pwm_duty_l);
*/

	encoder_create();

	thread_create();
	printf("thread_id=%d\n",(int)tasks[0]);
	pthread_join(tasks[0],NULL);
	printf("Program stopped\n");

}


